/*
 * atalk.h - AppleTalk conversion structures.....
 */

#define ATADDLEN	4
#define ATHTYPE		3			/* AppleTalk type */

unsigned char ATbseed[] = {0x00,0x00,0xff,0x48};
		/* use this when bseed[] is used for enet */

/*
 * AppleTalk Listener Interface structure
 */

#define	AIP		22
#define AARP	23
#define IPSock	72 					/* Later Change to random */

struct aTalk {
	short	count;
	unsigned char
			dest[ATADDLEN],	/* where the packet is going */
		 	me[ATADDLEN],
			type, paddingchars[3];		/* Give an even length so we will be at even */
	};

typedef struct aTalk ATdlayer;


/*
 * Here is the ARP packet structure  -  ATplummer
 */

struct ATplummer {
	ATdlayer d; 				/* data link layer packet header */

	unsigned short hrd,			/* hardware type, Ethernet = 1 */
			pro;			/* protocol type to resolve for */
	unsigned char	
			hln,			/* byte length of hardware addr = 6 for ETNET */
			pln;			/* byte length of protocol = 4 for IP */
	unsigned short op;			/* opcode, request = 1, reply = 2, RARP = 3,4 */
	unsigned char
			sha[ATADDLEN],
			spa[4],
			tha[ATADDLEN],
			tpa[4];
/*
*   the final four fields (contained in 'rest') are:
*      sender hardware address:   sha       hln bytes
*      sender protocol address:   spa       pln bytes
*      target hardware address:   tha       hln bytes
*      target protocol address:   tpa       pln bytes
*/
};

typedef struct ATplummer ATARPKT;

extern void getATaddress
  (
	int *hi,
	int *low,
	int *node
  );

extern int atopen
  (
	void
  );

extern int atclose
  (
	void
  );
