/*  FastNet Box 2				*/


/* General */
#ifdef PROTOTYPING
#define SCSI_ID			6						/* Fixed on all proto boxes */
#else
#ifdef SCSI_MASTER
int SCSI_ID = 6;
#else
extern int SCSI_ID;
#endif SCSI_MASTER
#endif PROTOTYPING

#define CMD_LENGTH		2

#define MAX_MULTICAST	6
#define MAX_PROTOCOL	8


/* Command types */

#define REQUEST_DATA		192
#define SENDING_DATA		193
#define	REQUESTING_STATUS	194
#define SENDING_COMMAND		195
#define REQUEST_ADDR		196

typedef struct {
	unsigned char	packetDestinationAddr[6];
	unsigned char	packetSourceAddr[6];
	unsigned int	packetType;
} EtherNetFrameHeader;

typedef struct {
	EtherNetFrameHeader	packetHeader;
	unsigned char		packetData[1500];
	unsigned char		packetCRC[4];
} FullEtherNetFrame;

typedef struct {
	EtherNetFrameHeader packetHeader;
	unsigned char		packetLength[2];
} DECNetFrameHeader;

typedef struct {
	DECNetFrameHeader	decnetHeader;
	unsigned char		packetData[];
} DECNetFrame;


typedef struct {
	unsigned int	promiscuousEnable;
	unsigned int	protocolCount;
	unsigned int	protocolType[MAX_PROTOCOL];			/* LSB ... MSB, frame order */
	unsigned int	multicastCount;
	unsigned char	physicalAddress[6];					/* LSB ... MSB, frame order */
	unsigned char	multicastAddress[MAX_MULTICAST][6];	/* Must come after physical */
	unsigned int	broadcastEnable;
} DataLinkData;
